#!/usr/bin/sh

touch /usr/share/applications/.lock
export TEXTDOMAIN="app-helper"
export TEXTDOMAINDIR="/usr/share/locale"

user=$(ps aux | awk '{print $1" "$11}' | sed -e 's|root.*||'| grep -v sddm |grep dbus-launch | awk '{print $1}' | sed 's|+||')

longname=$(users | grep ${user} | sed 's/root //'| awk '{print $1}')
[ "x$longname" = "x" -a "x$longname" = " " ]&&longname=$user

if [ "$(echo $longname |grep '^[a-zA-Z]')" = "" ];then
    echo "Not named user, get from group id"
    usernum=`echo "$longname" | grep '^[0-9]'`
    for anuser in `cat /etc/group | grep "$usernum" | awk -F: '{ print $1}'` ;do 
	users="$anuser $(echo "$longname" | sed "s|$usernum||" | uniq)"
    done
 else
    echo "[ ------ Great this this a named user --------- ] [$longname]"
    users=$longname
fi 

playsnd() { 
#$ECHO $E " (${FGRED}Playing sound..${FGDEF})"
if [ -f /usr/share/sounds/autoupdater.ogg ];then
sndfile=/usr/share/sounds/autoupdater.ogg 
elif [ -f /usr/share/sounds/autoupdater.oga ];then
sndfile=/usr/share/sounds/autoupdater.oga 
elif [ -f /usr/share/sounds/freedesktop/stereo/complete.oga ];then
sndfile=/usr/share/sounds/freedesktop/stereo/complete.oga
elif [ -f /usr/share/sounds/KDE-Im-Sms.ogg ];then
sndfile=/usr/share/sounds/KDE-Im-Sms.ogg 
elif [ -f /usr/share/sounds/KDE-Im-Sms.ogg ];then
sndfile=/usr/share/sounds/Oxygen-Im-Nudge.ogg 
fi

if (pidof pulseaudio &>/dev/null) ; then
    player="paplay -p"
else
    player="play -q"
fi

if [ "x" != "x$sndfile" ];then

for i in $users ;do
    ID=$(id -u $i)
done
    #$ECHO "XDG_RUNTIME_DIR=/run/user/$ID /usr/bin/$player $sndfile $(id -u $ID -n)" 
    su -c "XDG_RUNTIME_DIR=/run/user/$ID /usr/bin/$player $sndfile" $(id -u $ID -n) 
fi
}


sleep 1
locales=`cat /etc/sysconfig/i18n`
export $locales
export PATH=/usr/lib/blackPanther-default-apps/bin:$PATH
export DISPLAY=:0

if [ "$1" = "-u" ]||[ "$1" = "clean" ];then
echo -n "Find Removable App-Helper Items : "
find /usr/share/applications/ -type f \( ! -name "*.*" -o -name "*.desktop" ! -name "*app-helper.desktop" \) | while read Line ;do
    path=$(dirname "${Line}")
    filename=$(basename "${Line}")
    #[ "$2" = "DEBUG" ]&&echo "$path/$filename"
    helper=$(cat "$path/$filename"| grep ^Exec | grep "app-helper ")
    if [ -n "$helper" -a -f "$path/$filename" ];then
	[ "$2" = "DEBUG" ]&&echo 
	[ "$2" = "DEBUG" ]&&echo "Removed app-helper Item: $path/$filename"
	[ "$2" != "DEBUG" ]&&rm -f $path/$filename
    fi
    echo -n "#"
    done

echo ' [done]'

exit

fi

echo 

[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i system-search -t 10000 '$(gettext "App-Helper Preparing..")' \
'$(gettext "Search and clean older App-Helper items. Please wait! Do not restart the computer while running!")'" $users
playsnd

echo -n "[ ------ Find Installable App-Helper Items ---- ]"
FULL=0
IFS=$'\n'
[ ! -d /usr/share/applications/kde4 ] && mkdir -p /usr/share/applications/kde4
for app in $(find /usr/share/bP/app-helper/ -type f \( ! -name "*.*" -o -name "*.desktop" ! -name "*app-helper.desktop" \) ) ; do
    [ "$1" = "DEBUG" ]&& echo "App_$app"
    appname=`cat $app | grep ^Exec= |head -n 1| awk '{ print $3 }' | sed 's|).*||' 2>/dev/null`
    [ ! -n "$appname" ]&&appname=`cat $app | grep ^Exec= |head -n 1| awk '{ print $2 }' | sed 's|).*||' 2>/dev/null`
    [ ! -n "$appname" ]&& echo ERROR && exit 1
    [ "$1" = "DEBUG" ]&&echo ""
    [ "$1" = "DEBUG" ]&&echo "#----->APPNAME : $appname - $(echo $app| sed -e 's|/usr/share/bP/app-helper/||' -e 's|kde4/||')"
    deskfile=$(find /usr/share/applications/ -name `echo $app| sed -e 's|/usr/share/bP/app-helper/||' -e 's|kde4/||'`)
    [ "$1" = "DEBUG" ]&&echo "List: $app - Name:$appname - Desk:$deskfile"
    if [ -n "$app" ]&&[ ! -n "$deskfile" ];then
	[ "$1" = "DEBUG" ]&&echo "App: $app ]------------------->> [ Add ]"
	    [ ! -n "$deskfile" ]&&deskfile=$(echo $app| sed 's|/bP/app-helper|/applications|')
	    [ "$1" = "DEBUG" ]&&echo "Copy: cp -f $app - $deskfile"
	    if [ ! -n "$FOUND" -o "$1" != "DEBUG" ];then 
		cp -f "$app" "$deskfile"
		FULL=$(expr $FULL + 1)
		#echo "NOWFULL:$FULL"
		#sleep 1
	    fi
	else
	    [ "$1" = "DEBUG" ]&&echo "Skipped: The $deskfile already exists"
    fi
done

echo " [done]"
sleep 2
[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i view-refresh -t 30000 '$(gettext "App-Helper Setup")' \
'$(gettext "Looking for available applications. Please wait! Do not restart the computer while running!")'" $users

FULL=$(find /usr/share/bP/app-helper/ -type f \( ! -name "*.*" -o -name '*.desktop' ! -name "*app-helper.desktop" ! -name "*teamviewer*.desktop" \) | wc -l)
FULL=`expr $FULL / 8`
[ ! -n "$FULL" ] && FULL=140
echo -n "[ ------ Find UnStored App-Helper Items ------- ]"
COUNT="0"
PERCENT="12.5"
FULLCOUNT="0"
for i in `find /usr/share/applications -type f \( ! -name "*.*" -o -name '*.desktop' ! -name "*app-helper.desktop" ! -name "*teamviewer*.desktop" \)`; do
    
    #[ "$1" = "DEBUG" ]&&echo "FindApp : $i"

    HELPER=$(cat "$i" | grep "app-helper ")
    if [ "x" != "x$HELPER" ];then

    FULLCOUNT=$(expr $FULLCOUNT + 1)
    
    COUNT=$(expr $COUNT + 1)
    
    [ "$1" = "DEBUG" ]&&echo
    [ "$1" = "DEBUG" ]&&echo "==> AppHelper Item :$i -- Exec: $HELPER"

     appname=`cat $i | grep ^Exec= | awk '{ print $3 }' | sed 's|).*||' | head -n 1 2>/dev/null`
     [ ! -n "$appname" ]&&appname=`cat $i | grep ^Exec= |head -n 1| awk '{ print $2 }' | sed 's|).*||' 2>/dev/null`

     if [ -n "$appname" ];then
        [ "$1" = "DEBUG" ]&&echo -n "==> App Name:[ $appname ]" 
        deskfile=$(perl /usr/bin/urpmq -l $appname 2>/dev/null | grep applications/ | grep '.desktop$'| grep "$appname" | head -n 1)
        [ "$1" = "DEBUG" ]&&echo -n " Deskfile: $deskfile"
        
        if [ ! -n "$deskfile" ];then
	    deskfile=$(perl /usr/bin/urpmq -l $appname 2>/dev/null | grep applications/ | grep '.desktop$'| head -n 1 2>/dev/null)
	    [ "$1" = "DEBUG" ]&&echo -n "-- $deskfile"
        fi
        
        if [ -n "$appname" ]&&[ ! -n "$deskfile" ];then
	    [ -f "$i" -a "$1" = "DEBUG" ] && echo "$i [ * Removed * ]"
	    [ -f "$i" -o "$1" != "DEBUG" ] && rm -f "$i"
	    #sleep 2
	    #COUNT=$(expr $COUNT + 1)
	    else
	    [ "$1" = "DEBUG" ]&& echo " [ Stored! ]"
	    #COUNT=$(expr $COUNT + 1)
        fi
      
      fi
      
    fi

	    if [ "$COUNT" = "$FULL" ];then
	    [ -n "$DISPLAY" ] && su -c "notify-send -u normal -i view-refresh -t 6000 '$(gettext "App-Helper Still Running..")' \
	    '"$(echo ${PERCENT}|sed 's|\.0||')"% - $(gettext 'You will get a notification when process is finished. Plesae wait!')'" $users
	    COUNT=0
	    PERCENT=$(echo "scale=2; $PERCENT + 12.5" | bc)
	    fi

	    [ "$1" = "DEBUG" ]&&echo "==> [$FULLCOUNT] $COUNT - $FULL * $PERCENT"
    
done
echo " [done]"

[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i system-help -t 10000 '$(gettext "App-Helper Checking")' \
'$(gettext "Installed items double check.. Please wait a little bit! Almost Ready, do not restaring!")'" $users
sleep 2
echo -n "[ ------ Find and Fix Sercvicemenu items ------ ]"
# Service menus fixating progress
find /usr/share/kservices5/ServiceMenus -type f \( ! -name "*.*" -o -name "*.desktop" ! -name "*app-helper.desktop" \) | while read Line
do
    path=$(dirname "${Line}")
    filename=$(basename "${Line}")
    helper=$(cat "$path/$filename"| grep ^Exec=app-helper)
    if [ -n "$helper" ];then
	APP=$(echo $helper | awk '{print $2}')
	[ "$1" = "DEBUG" ]&&echo "Removed app-helper Item: $path/$filename $APP"
	sed -i -e "s|Exec=app-helper .*|Exec=sh \"\$(/usr/bin/app-helper.bin $APP)\"|" $path/$filename
    fi
    [ "$1" = "DEBUG" ]&&echo -n "#"
done

echo -n " [done]"
echo
playsnd
[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i security-high -t 16000 '$(gettext "App-Helper Done!")' \
'$(gettext "Available applications are installed to Your menu!")'" $users

# broken kate icon
#rm -f /usr/share/applications/kde/*kate*.desktop 2 >/dev/null

# broken krusader
#rm -f /usr/share/applications/kde/*krusader*.desktop 2 >/dev/null

# clean lock
rm -f /usr/share/applications/.lock
